<template>
  <main>
    <section class="section">
      <h1 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.main_title') }}
      </h1>
      <p
        v-html="$t('pages.contribute.collectGuide.main_description')"
        class="main-description"
      ></p>
      <ul class="summary-list">
        <li v-for="link in summaryLinks" class="summary-title">
          <a :href="link.id">#{{ link.text }}</a>
        </li>
      </ul>
    </section>
    <section class="section" id="objective">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.objective_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.objective_description')"></p>
      <div class="entry-info-card">
        <InformationCard
          :title="$t('pages.contribute.collectGuide.objective_warning_title')"
          :text="
            $t('pages.contribute.collectGuide.objective_warning_description')
          "
          look="blue"
        />
      </div>
    </section>
    <section class="section" id="equipment">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.equipment_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.equipment_description')"></p>
    </section>
    <section class="section" id="config">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.config_title') }}
      </h2>
      <p
        v-html="
          $t('pages.contribute.collectGuide.config_description.introduction')
        "
      />
      <ul class="config-list">
        <template v-for="step in configDescriptionSteps">
          <li v-if="!step.warning_title" class="config-item">
            <div>
              <p v-if="step.text" class="config-item-text">{{ step.text }}</p>
              <div v-if="step.img">
                <img
                  v-for="image in step.img"
                  :src="img(image.url)"
                  :alt="img(image.alt)"
                  class="config-item-img"
                />
              </div>
              <p
                v-if="step.text_continuation"
                class="config-item-text-continuation"
              >
                {{ step.text_continuation }}
              </p>
            </div>
          </li>
          <div v-else class="wrapper-info-card">
            <InformationCard
              :title="step.warning_title"
              :text="step.warning_text"
              look="blue"
            />
          </div>
        </template>
      </ul>
    </section>
    <section class="section" id="prepare">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.setup_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.setup_description')"></p>
      <div class="entry-info-card">
        <InformationCard
          :title="$t('pages.contribute.collectGuide.setup_warning_title')"
          :text="$t('pages.contribute.collectGuide.setup_warning_description')"
          look="white"
        />
      </div>
    </section>
    <section class="section" id="collect">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.collect_title') }}
      </h2>
      <p
        v-html="
          $t('pages.contribute.collectGuide.collect_description.introduction')
        "
      />
      <ul class="config-list">
        <template v-for="step in collectDescriptionSteps">
          <li v-if="!step.warning_title" class="config-item">
            <div>
              <p v-if="step.text" class="config-item-text">{{ step.text }}</p>
              <div v-if="step.img">
                <img
                  v-for="image in step.img"
                  :src="img(image.url)"
                  :alt="img(image.alt)"
                  class="config-item-img"
                />
              </div>
              <p
                v-if="step.text_continuation"
                class="config-item-text-continuation"
              >
                {{ step.text_continuation }}
              </p>
            </div>
          </li>
          <div v-else class="wrapper-info-card">
            <InformationCard
              :title="step.warning_title"
              :text="step.warning_text"
              look="blue"
            />
          </div>
        </template>
      </ul>
      <p
        v-html="
          $t(
            'pages.contribute.collectGuide.collect_description.introduction_continuation'
          )
        "
        class="contribute-continuation"
      />
      <ul class="config-list">
        <template v-for="step in collectDescriptionStepsContinuation">
          <li
            v-if="!step.warning_title"
            :class="['config-item', !step.text ? 'item-no-text' : '']"
          >
            <div>
              <p v-if="step.text" class="config-item-text">{{ step.text }}</p>
              <div v-if="step.img">
                <img
                  v-for="image in step.img"
                  :src="img(image.url)"
                  :alt="img(image.alt)"
                  class="config-item-img"
                />
              </div>
              <p
                v-if="step.text_continuation"
                class="config-item-text-continuation"
              >
                {{ step.text_continuation }}
              </p>
            </div>
          </li>
          <div v-else class="info-card wrapper-info-card">
            <InformationCard
              :title="step.warning_title"
              :text="step.warning_text"
              look="blue"
            />
          </div>
        </template>
      </ul>
    </section>
    <section class="section" id="processing">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.processing_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.processing_description')" />
      <div class="processing-warning">
        <InformationCard
          :title="$t('pages.contribute.collectGuide.processing_warning_title')"
          :text="
            $t('pages.contribute.collectGuide.processing_warning_description')
          "
          look="white"
        />
      </div>
      <p
        v-html="
          $t(
            'pages.contribute.collectGuide.processing_description_continuation'
          )
        "
      />
    </section>
    <section class="section" id="send">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.send_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.send_description')"></p>
      <div class="processing-warning">
        <InformationCard
          :title="$t('pages.contribute.collectGuide.send_warning_title')"
          :text="$t('pages.contribute.collectGuide.send_warning_description')"
          look="blue"
        />
      </div>
      <p
        v-html="
          $t('pages.contribute.collectGuide.send_description_continuation')
        "
      />
      <div class="processing-warning">
        <InformationCard
          :title="
            $t('pages.contribute.collectGuide.send_warning_title_continuation')
          "
          :text="
            $t(
              'pages.contribute.collectGuide.send_warning_description_continuation'
            )
          "
          look="blue"
        />
      </div>
    </section>
    <section class="section" id="share">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.share_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.share_description')"></p>
      <img :src="img(shareImg.url)" :alt="shareImg.alt" class="share-image" />
    </section>
    <section class="section" id="after">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.after_title') }}
      </h2>
      <p v-html="$t('pages.contribute.collectGuide.after_description')"></p>
    </section>
    <section class="section" id="security">
      <h2 class="contribute-section-title">
        {{ $t('pages.contribute.collectGuide.security_title') }}
      </h2>
      <div v-for="step in securityDescriptionSteps" class="wrapper-security">
        <div v-if="!step.warning_title">
          <h3 v-if="step.title" class="wrapper-security">{{ step.title }}</h3>
          <p v-if="step.text" v-html="step.text" />
        </div>
        <div v-else class="info-card wrapper-security">
          <InformationCard
            :title="step.warning_title"
            :text="step.warning_text"
            look="white"
          />
        </div>
      </div>
    </section>
  </main>
</template>

<script lang="ts" setup>
import { computed } from 'vue'
import { useI18n } from 'vue-i18n'
import { tmWrapper } from '@/utils'
import { img } from '../utils/image'
import InformationCard from '@/components/InformationCard.vue'
const { t } = useI18n()

interface DescriptionStep {
  text?: string
  title?: string
  img?: { url: string; alt: string }[]
  text_continuation?: string
  warning_title?: string
  warning_text?: string
}
const summaryLinks = computed((): { id: string; text: string }[] => [
  {
    id: '#objective',
    text: t('pages.contribute.collectGuide.summary_link_objective')
  },
  {
    id: '#equipment',
    text: t('pages.contribute.collectGuide.summary_link_equipment')
  },
  {
    id: '#config',
    text: t('pages.contribute.collectGuide.summary_link_configuration')
  },
  {
    id: '#collect',
    text: t('pages.contribute.collectGuide.summary_link_prepare')
  },
  {
    id: '#prepare',
    text: t('pages.contribute.collectGuide.summary_link_collect')
  },
  {
    id: '#processing',
    text: t('pages.contribute.collectGuide.summary_link_processing')
  },
  {
    id: '#send',
    text: t('pages.contribute.collectGuide.summary_link_send')
  },
  {
    id: '#share',
    text: t('pages.contribute.collectGuide.summary_link_share')
  },
  {
    id: '#after',
    text: t('pages.contribute.collectGuide.summary_link_after')
  },
  {
    id: '#security',
    text: t('pages.contribute.collectGuide.summary_link_security')
  }
])
const configDescriptionSteps = computed((): DescriptionStep[] => [
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_open_gopro.text'
    ),
    img: [
      {
        url: 'image-gopro1.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_open_gopro.img_alt_gopro_charge'
        )
      },
      {
        url: 'image-gopro2.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_open_gopro.img_alt_gopro_card'
        )
      }
    ]
  },
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_insert_card.text'
    ),
    img: [
      {
        url: 'image-gopro3.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_insert_card.img_alt_gopro_insert_card'
        )
      }
    ]
  },
  tmWrapper('pages.contribute.collectGuide.config_description.block_battery'),
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_close.text'
    ),
    img: [
      {
        url: 'image-gopro4.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_close.img_alt_gopro_close'
        )
      }
    ]
  },
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_push_button.text'
    ),
    img: [
      {
        url: 'image-gopro5.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_push_button.img_alt_gopro_onoff'
        )
      }
    ]
  },
  tmWrapper(
    'pages.contribute.collectGuide.config_description.block_accelerate'
  ),
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_swipe.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro1.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_swipe.img_alt_gopro_chronos'
        )
      }
    ]
  },
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_button_bottom.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro2.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_button_bottom.img_alt_button'
        )
      }
    ],
    text_continuation: t(
      'pages.contribute.collectGuide.config_description.block_button_bottom.text_continuation'
    )
  },
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_timeWarp_360.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro3.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_timeWarp_360.img_alt_button_edit'
        )
      }
    ]
  },
  tmWrapper('pages.contribute.collectGuide.config_description.block_format'),
  tmWrapper('pages.contribute.collectGuide.config_description.block_interval'),
  tmWrapper('pages.contribute.collectGuide.config_description.block_arrow_top'),
  tmWrapper(
    'pages.contribute.collectGuide.config_description.block_screen_check'
  ),
  tmWrapper('pages.contribute.collectGuide.config_description.block_warning'),
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_swipe_bottom.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro4.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_swipe_bottom.img_alt_button_list'
        )
      }
    ]
  },
  tmWrapper('pages.contribute.collectGuide.config_description.block_settings'),
  tmWrapper(
    'pages.contribute.collectGuide.config_description.block_default_mode'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.config_description.block_last_option'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.config_description.block_button_fast'
  ),
  {
    text: t(
      'pages.contribute.collectGuide.config_description.block_button_fast.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro5.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_button_fast.img_alt_button_list'
        )
      }
    ]
  },
  tmWrapper('pages.contribute.collectGuide.config_description.block_music'),
  tmWrapper('pages.contribute.collectGuide.config_description.block_date')
])
const collectDescriptionSteps = computed((): DescriptionStep[] => [
  tmWrapper('pages.contribute.collectGuide.collect_description.block_safety'),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_warning_turn'
  ),
  tmWrapper('pages.contribute.collectGuide.collect_description.block_360'),
  {
    text: t(
      'pages.contribute.collectGuide.collect_description.block_attach_gopro.text'
    ),
    img: [
      {
        url: 'image-multi-gopro.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_attach_gopro.img_alt_button_list'
        )
      }
    ]
  },
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_remove_lens'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_warning_cover'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_direction'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_warning_position'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_pole_position'
  ),
  {
    text: t(
      'pages.contribute.collectGuide.collect_description.block_shutter.text'
    ),
    img: [
      {
        url: 'image-gopro6.svg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_shutter.img_alt_button_top'
        )
      }
    ]
  }
])
const collectDescriptionStepsContinuation = computed((): DescriptionStep[] => [
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_check_start'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_warning_mode'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_check_camera'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_hold'
  ),
  {
    img: [
      {
        url: 'image-person.jpg',
        alt: t(
          'pages.contribute.collectGuide.config_description.block_continuation_hold_img.img_alt_person_gopro'
        )
      }
    ]
  },
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_correct_position'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_stability'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_warning_sensor'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_warning_tunnel_sensor'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_stop'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_straight'
  ),
  {
    text: t(
      'pages.contribute.collectGuide.collect_description.block_continuation_regularity.text'
    ),
    img: [
      {
        url: 'image-ecran-gopro6.jpg',
        alt: t(
          'pages.contribute.collectGuide.collect_description.block_continuation_hold_img.img_alt_battery'
        )
      }
    ]
  },
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_regularity'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.collect_description.block_continuation_warning_battery'
  )
])
const securityDescriptionSteps = computed((): DescriptionStep[] => [
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_security'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_collect_condition'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_equipment'
  ),
  tmWrapper('pages.contribute.collectGuide.security_description.block_collect'),
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_warning_recommendations'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_interactions'
  ),
  tmWrapper(
    'pages.contribute.collectGuide.security_description.block_authorizations'
  )
])
const shareImg = computed((): { url: string; alt: string } => {
  return {
    url: 'image-viewer.jpg',
    alt: tmWrapper('pages.contribute.collectGuide.share_img.alt')
  }
})
</script>

<style scoped lang="scss">
.section {
  padding: 3rem 20%;
}
.section:nth-child(even) {
  background-color: var(--white);
}
.section:nth-child(odd) {
  background-color: var(--grey);
}
.contribute-section-title {
  @include title();
  margin-bottom: 2rem;
}
.processing-warning {
  margin-top: 2rem;
  margin-bottom: 2rem;
}
.summary-list {
  margin-top: 2rem;
  position: fixed;
  top: 9rem;
  left: 2rem;
  z-index: 1;
  border-left: 0.1rem solid var(--grey-pale);
  padding-left: 1rem;
}
.summary-title {
  margin-top: 1rem;
  &:first-child {
    margin-top: 0;
  }
  a {
    color: var(--blue-dark);
    text-decoration: none;
  }
}
p {
  white-space: pre-wrap;
  color: var(--grey-dark);
}
.config-list {
  display: flex;
  flex-wrap: wrap;
  gap: 2rem;
  margin-top: 2rem;
}
.config-item {
  width: calc(33% - 2rem);
  border-radius: 2rem;
  padding: 2rem;
  background-color: var(--blue-ligth);
}
.config-item-text {
  margin-bottom: 1.5rem;
}
.config-item-img {
  height: 12rem;
}
.config-item-text-continuation {
  margin-top: 1.5rem;
}
.entry-info-card {
  margin-top: 2rem;
}
.info-card {
  width: 100%;
}
.wrapper-info-card {
  width: calc(66% - 2rem);
}
.item-no-text {
  background-color: white;
  .config-item-img {
    height: 30rem;
    position: absolute;
  }
}
.contribute-continuation {
  margin-top: 2rem;
}
.share-image {
  margin-top: 2rem;
  width: 100%;
}
.wrapper-security {
  margin-bottom: 2rem;
}
@media (max-width: 1324px) {
  .section {
    padding: 3rem 10%;
  }
  .summary-list {
    position: initial;
  }
}
@media (max-width: 1024px) {
  .config-item {
    width: calc(50% - 1rem);
  }
  .item-no-text {
    .config-item-img {
      height: initial;
      position: initial;
    }
  }
  .wrapper-info-card {
    width: calc(50% - 1rem);
  }
}
@media (max-width: 768px) {
  .section {
    padding-right: 2rem;
    padding-left: 2rem;
  }
  .contribute-section-title {
    font-size: 2rem;
  }
  .wrapper-info-card {
    width: 100%;
  }
}
@media (max-width: 500px) {
  .config-item {
    width: 100%;
  }
  p {
    font-size: 1.4rem;
  }
}
</style>
